<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: Allocator.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Allocator.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// -----------</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// Allocator.h</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">// -----------</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;</div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#ifndef Allocator_h</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#define Allocator_h</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">// --------</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment">// includes</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment">// --------</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;</div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &lt;cassert&gt;</span>   <span class="comment">// assert</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;cstddef&gt;</span>   <span class="comment">// ptrdiff_t, size_t</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &lt;new&gt;</span>       <span class="comment">// bad_alloc, new</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &lt;stdexcept&gt;</span> <span class="comment">// invalid_argument</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span>  <span class="comment">// cin, cout</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="keyword">const</span> <span class="keywordtype">int</span> OBJ_SIZE = 8;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment">// ---------</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment">// Allocator</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment">// ---------</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, std::<span class="keywordtype">size_t</span> N&gt;</div><div class="line"><a name="l00025"></a><span class="lineno"><a class="line" href="classmy__allocator.html">   25</a></span>&#160;<span class="keyword">class </span><a class="code" href="classmy__allocator.html">my_allocator</a> {</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="comment">// -----------</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="comment">// operator ==</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    <span class="comment">// -----------</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <span class="keyword">friend</span> <span class="keywordtype">bool</span> operator == (<span class="keyword">const</span> <a class="code" href="classmy__allocator.html">my_allocator</a>&amp; lhs, <span class="keyword">const</span> <a class="code" href="classmy__allocator.html">my_allocator</a>&amp; rhs) {</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;        <span class="keywordflow">return</span> lhs == rhs;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    }</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    <span class="comment">// -----------</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="comment">// operator !=</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="comment">// -----------</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="keyword">friend</span> <span class="keywordtype">bool</span> operator != (<span class="keyword">const</span> <a class="code" href="classmy__allocator.html">my_allocator</a>&amp; lhs, <span class="keyword">const</span> <a class="code" href="classmy__allocator.html">my_allocator</a>&amp; rhs) {</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;        <span class="keywordflow">return</span> !(lhs == rhs);</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    }</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    <span class="comment">// --------</span></div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="comment">// typedefs</span></div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <span class="comment">// --------</span></div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="keyword">using</span>      value_type = T;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="keyword">using</span>       size_type = std::size_t;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="keyword">using</span> difference_type = std::ptrdiff_t;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    <span class="keyword">using</span>       pointer   =       value_type*;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="keyword">using</span> const_pointer   = <span class="keyword">const</span> value_type*;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="keyword">using</span>       reference =       value_type&amp;;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="keyword">using</span> const_reference = <span class="keyword">const</span> value_type&amp;;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="comment">// ----</span></div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    <span class="comment">// data</span></div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <span class="comment">// ----</span></div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <span class="keywordtype">char</span> a[N + <span class="keyword">sizeof</span>(int)];</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="comment">// -----</span></div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="comment">// valid</span></div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <span class="comment">// -----</span></div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <span class="keywordtype">bool</span> valid ()<span class="keyword"> const </span>{</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;        <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a> b = this-&gt;<a class="code" href="classmy__allocator.html#a7b5afad4b9378cb1a582fe1c8d229a60">begin</a>();</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a> e = this-&gt;<a class="code" href="classmy__allocator.html#a16254433a0dbd050ec409090f7e9777e">end</a>();</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;        <span class="keywordflow">while</span> (b != e) {</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;            ++b;</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;        }</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    }</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    <span class="comment">// --------</span></div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    <span class="comment">// iterator</span></div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    <span class="comment">// --------</span></div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;</div><div class="line"><a name="l00088"></a><span class="lineno"><a class="line" href="classmy__allocator_1_1iterator.html">   88</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classmy__allocator_1_1iterator.html">iterator</a> {</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;        <span class="comment">// operator ==</span></div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        <span class="keyword">friend</span> <span class="keywordtype">bool</span> operator == (<span class="keyword">const</span> <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a>&amp; lhs, <span class="keyword">const</span> <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a>&amp; rhs) {</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;            <span class="keywordflow">return</span> &amp;(*lhs) == &amp;(*rhs);</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        }</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;        <span class="comment">// operator !=</span></div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;        <span class="keyword">friend</span> <span class="keywordtype">bool</span> operator != (<span class="keyword">const</span> <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a>&amp; lhs, <span class="keyword">const</span> <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a>&amp; rhs) {</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;            <span class="keywordflow">return</span> !(lhs == rhs);</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        }</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;        <span class="comment">// ----</span></div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;        <span class="comment">// data</span></div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;        <span class="comment">// ----</span></div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;        <span class="keywordtype">int</span>* _p;</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;        <span class="comment">// constructor</span></div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;        <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a> (<span class="keywordtype">int</span>* p) {</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;            _p = p;</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;        }</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        <span class="comment">// ----------</span></div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;        <span class="comment">// operator *</span></div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;        <span class="comment">// ----------</span></div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;        <span class="keywordtype">int</span>&amp; operator * ()<span class="keyword"> const </span>{</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;            <span class="keywordflow">return</span> *_p;</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;        }</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;        <span class="comment">// operator ++</span></div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;        <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a>&amp; operator ++ () {</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;            <span class="keywordtype">char</span>* temp = (<span class="keywordtype">char</span>*) _p;</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;            <span class="keywordtype">int</span> v = *_p;</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;            v = v &gt; 0 ? v : v * -1;</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;            temp += 2 * <span class="keyword">sizeof</span>(int) + v;</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;            _p = (<span class="keywordtype">int</span>*) temp;</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;            <span class="keywordflow">return</span> *<span class="keyword">this</span>;</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;        }</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;        <span class="comment">// operator ++</span></div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;        <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a> operator ++ (<span class="keywordtype">int</span>) {</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;            <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a> x = ++*<span class="keyword">this</span>;</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;            <span class="keywordflow">return</span> x;</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;        }</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        <span class="comment">// operator --</span></div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;        <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a>&amp; operator -- () {</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;            <span class="keywordtype">char</span>* temp = (<span class="keywordtype">char</span>*) _p;</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;            <span class="keywordtype">int</span> v = *(_p - 1);</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;            v = v &gt; 0 ? v : v * -1;</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;            temp -= 2 * <span class="keyword">sizeof</span>(int) + v;</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;            _p = (<span class="keywordtype">int</span>*) temp;</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;            <span class="keywordflow">return</span> *<span class="keyword">this</span>;</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;        }</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;        <span class="comment">// operator --</span></div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;        <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a> operator -- (<span class="keywordtype">int</span>) {</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;            <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a> x = --*<span class="keyword">this</span>;</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;            <span class="keywordflow">return</span> x;</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;        }</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;    };</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;    <span class="comment">// --------------</span></div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;    <span class="comment">// const_iterator</span></div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;    <span class="comment">// --------------</span></div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;</div><div class="line"><a name="l00180"></a><span class="lineno"><a class="line" href="classmy__allocator_1_1const__iterator.html">  180</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a> {</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;        <span class="comment">// operator ==</span></div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;        <span class="keyword">friend</span> <span class="keywordtype">bool</span> operator == (<span class="keyword">const</span> <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a>&amp; lhs, <span class="keyword">const</span> <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a>&amp; rhs) {</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;            <span class="keywordflow">return</span> &amp;(*lhs) == &amp;(*rhs);</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;        }</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;        <span class="comment">// operator !=</span></div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;        <span class="keyword">friend</span> <span class="keywordtype">bool</span> operator != (<span class="keyword">const</span> <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a>&amp; lhs, <span class="keyword">const</span> <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a>&amp; rhs) {</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;            <span class="keywordflow">return</span> !(lhs == rhs);</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;        }</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;        <span class="comment">// ----</span></div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;        <span class="comment">// data</span></div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;        <span class="comment">// ----</span></div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">int</span>* _p;</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;        <span class="comment">// constructor</span></div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;        <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a> (<span class="keyword">const</span> <span class="keywordtype">int</span>* p) {</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;            _p = p;</div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;        }</div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;</div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;        <span class="comment">// ----------</span></div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;        <span class="comment">// operator *</span></div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;        <span class="comment">// ----------</span></div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">int</span>&amp; operator * ()<span class="keyword"> const </span>{</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;            <span class="keywordflow">return</span> *_p;</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;        }</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;        <span class="comment">// operator ++</span></div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;</div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;        <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a>&amp; operator ++ () {</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;            <span class="keywordtype">char</span>* temp = (<span class="keywordtype">char</span>*) _p;</div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;            <span class="keywordtype">int</span> v = *_p;</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;            v = v &gt; 0 ? v : v * -1;</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;            temp += 2 * <span class="keyword">sizeof</span>(int) + v;</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;            _p = (<span class="keywordtype">int</span>*) temp;</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;            <span class="keywordflow">return</span> *<span class="keyword">this</span>;</div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;        }</div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;        <span class="comment">// operator ++</span></div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;        <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a> operator ++ (<span class="keywordtype">int</span>) {</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;            <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a> x = *<span class="keyword">this</span>;</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;            ++*<span class="keyword">this</span>;</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;            <span class="keywordflow">return</span> x;</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;        }</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;        <span class="comment">// operator --</span></div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;</div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;        <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a>&amp; operator -- () {</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;            <span class="keywordtype">char</span>* temp = (<span class="keywordtype">char</span>*) _p;</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;            <span class="keywordtype">int</span> v = *(_p - 1);</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;            v = v &gt; 0 ? v : v * -1;</div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;</div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;            temp -= 2 * <span class="keyword">sizeof</span>(int) + v;</div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;            _p = (<span class="keywordtype">int</span>*) temp;</div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;            <span class="keywordflow">return</span> *<span class="keyword">this</span>;</div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;        }</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;        <span class="comment">// operator --</span></div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;</div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;        <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a> operator -- (<span class="keywordtype">int</span>) {</div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;            <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a> x = *<span class="keyword">this</span>;</div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;            --*<span class="keyword">this</span>;</div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;            <span class="keywordflow">return</span> x;</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;        }</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;    };</div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;    <span class="comment">// -----------</span></div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;    <span class="comment">// constructor</span></div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;    <span class="comment">// -----------</span></div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;</div><div class="line"><a name="l00279"></a><span class="lineno"><a class="line" href="classmy__allocator.html#ae072d6037f9f72b54303533033ed188d">  279</a></span>&#160;    <a class="code" href="classmy__allocator.html#ae072d6037f9f72b54303533033ed188d">my_allocator</a> () {</div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;        assert (N &gt;= <span class="keyword">sizeof</span>(T) + (2 * <span class="keyword">sizeof</span>(<span class="keywordtype">int</span>)));</div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;</div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;        *(<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">int</span>*<span class="keyword">&gt;</span>(&amp;a[0])) = N - (2 * <span class="keyword">sizeof</span>(int));</div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;        *(<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">int</span>*<span class="keyword">&gt;</span>(&amp;a[N - <span class="keyword">sizeof</span>(int)])) = N - (2* <span class="keyword">sizeof</span>(<span class="keywordtype">int</span>));</div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;        *(<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">int</span>*<span class="keyword">&gt;</span>(&amp;a[N])) = 0;</div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;        assert(valid());</div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;    }</div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;</div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;    <a class="code" href="classmy__allocator.html#ae072d6037f9f72b54303533033ed188d">my_allocator</a>             (<span class="keyword">const</span> <a class="code" href="classmy__allocator.html">my_allocator</a>&amp;) = <span class="keywordflow">default</span>;</div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;    ~<a class="code" href="classmy__allocator.html">my_allocator</a>            ()                    = <span class="keywordflow">default</span>;</div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;    <a class="code" href="classmy__allocator.html">my_allocator</a>&amp; operator = (<span class="keyword">const</span> <a class="code" href="classmy__allocator.html">my_allocator</a>&amp;) = <span class="keywordflow">default</span>;</div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;</div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;    <span class="comment">// --------</span></div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;    <span class="comment">// allocate</span></div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;    <span class="comment">// --------</span></div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;</div><div class="line"><a name="l00304"></a><span class="lineno"><a class="line" href="classmy__allocator.html#ab9b3cc6d95fad1ab70c09bc1c4de2597">  304</a></span>&#160;    pointer <a class="code" href="classmy__allocator.html#ab9b3cc6d95fad1ab70c09bc1c4de2597">allocate</a> (size_type n)<span class="keyword"> const </span>{</div><div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;        <span class="keywordflow">if</span> (n &lt;= 0) {</div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;            std::bad_alloc exception;</div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;            <span class="keywordflow">throw</span> exception;</div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;        }</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;</div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;        <span class="keywordtype">int</span> _n = n * OBJ_SIZE;</div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;        <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a> b = this-&gt;<a class="code" href="classmy__allocator.html#a7b5afad4b9378cb1a582fe1c8d229a60">begin</a>();</div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;        <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a> e = this-&gt;<a class="code" href="classmy__allocator.html#a16254433a0dbd050ec409090f7e9777e">end</a>();</div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;</div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;        <span class="keywordflow">while</span> (b != e) {</div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;            <span class="keywordflow">if</span> (*b &lt; 0) {</div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;                <span class="comment">// Nothing</span></div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;            }</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;            <span class="comment">// n fits perfectly in b</span></div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;            <span class="keywordflow">else</span> <span class="keywordflow">if</span> (*b == _n || ( *b &gt; _n &amp;&amp; (*b - _n) &lt;= OBJ_SIZE )) {</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;                <span class="comment">// Get sentinels</span></div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;                <span class="keywordtype">char</span>* sen_1 = (<span class="keywordtype">char</span>*) &amp;(*b);</div><div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;                <span class="keywordtype">char</span>* sen_2 = sen_1 + <span class="keyword">sizeof</span>(int) + *b;</div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;</div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;                <span class="comment">// Set sentinels</span></div><div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;                *(<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">int</span>*<span class="keyword">&gt;</span>(sen_1)) *= -1;</div><div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;                *(<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">int</span>*<span class="keyword">&gt;</span>(sen_2)) *= -1;</div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;</div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;                <span class="comment">// Return first sentinel</span></div><div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;                assert(valid());</div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;                <span class="keywordflow">return</span> (pointer) ((<span class="keywordtype">char</span>*) sen_1 + <span class="keyword">sizeof</span>(<span class="keywordtype">int</span>));</div><div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;            }</div><div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;</div><div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;            <span class="comment">// n fits in b</span></div><div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;            <span class="keywordflow">else</span> <span class="keywordflow">if</span> (*b &gt; _n) {</div><div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;                <span class="comment">// Get sentinels</span></div><div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;                <span class="keywordtype">char</span>* sen_1 = (<span class="keywordtype">char</span>*) &amp;(*b);</div><div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;                <span class="keywordtype">char</span>* sen_2 = sen_1 + <span class="keyword">sizeof</span>(int) + _n;</div><div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;                <span class="keywordtype">char</span>* sen_3 = sen_2 + <span class="keyword">sizeof</span>(int);</div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;                <span class="keywordtype">char</span>* sen_4 = sen_1 + <span class="keyword">sizeof</span>(int) + *b;</div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;</div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;                <span class="comment">// Set sentinels</span></div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;                *(<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">int</span>*<span class="keyword">&gt;</span>(sen_3))  = *b - _n - <span class="keyword">sizeof</span>(int) * 2;</div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;                *(<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">int</span>*<span class="keyword">&gt;</span>(sen_4))  = *b - _n - <span class="keyword">sizeof</span>(int) * 2;</div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;                *(<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">int</span>*<span class="keyword">&gt;</span>(sen_1))  = -1 * _n;</div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;                *(<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">int</span>*<span class="keyword">&gt;</span>(sen_2))  = -1 * _n;</div><div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;</div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;                <span class="comment">// Return first sentinel</span></div><div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;                assert(valid());</div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;                <span class="keywordflow">return</span> (<span class="keyword">const</span> pointer) ((<span class="keywordtype">char</span>*) sen_1 + <span class="keyword">sizeof</span>(<span class="keywordtype">int</span>));</div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;            }</div><div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;</div><div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;            <span class="comment">//n didn&#39;t fit in b</span></div><div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;            ++b;</div><div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;        }</div><div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;</div><div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;        <span class="comment">// No available blocks</span></div><div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;        assert(valid());</div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">nullptr</span>;</div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;    }</div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;</div><div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;    <span class="comment">// ---------</span></div><div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;    <span class="comment">// construct</span></div><div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;    <span class="comment">// ---------</span></div><div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160;</div><div class="line"><a name="l00370"></a><span class="lineno"><a class="line" href="classmy__allocator.html#a821500e9bdd812dd28bcf1740f2fdd58">  370</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classmy__allocator.html#a821500e9bdd812dd28bcf1740f2fdd58">construct</a> (pointer p, const_reference v)<span class="keyword"> const  </span>{</div><div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;        <span class="keyword">new</span> (p) T(v);                               <span class="comment">// this is correct and exempt</span></div><div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;        assert(valid());</div><div class="line"><a name="l00373"></a><span class="lineno">  373</span>&#160;    }                           <span class="comment">// from the prohibition of new</span></div><div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;</div><div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;    <span class="comment">// ----------</span></div><div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;    <span class="comment">// deallocate</span></div><div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;    <span class="comment">// ----------</span></div><div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;</div><div class="line"><a name="l00386"></a><span class="lineno"><a class="line" href="classmy__allocator.html#af88d75eee73684bd8d2c42f663c4dd37">  386</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classmy__allocator.html#af88d75eee73684bd8d2c42f663c4dd37">deallocate</a> (pointer p, size_type n)<span class="keyword"> const </span>{</div><div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;        <span class="comment">// Get sentinels</span></div><div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160;        <span class="keywordtype">char</span>* sen_1 = ((<span class="keywordtype">char</span>*) p) - <span class="keyword">sizeof</span>(int);</div><div class="line"><a name="l00389"></a><span class="lineno">  389</span>&#160;        <span class="keywordtype">char</span>* sen_2 = sen_1 + <span class="keyword">sizeof</span>(int) - *(reinterpret_cast&lt;int*&gt;(sen_1));</div><div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160;</div><div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;        assert(*(reinterpret_cast&lt;int*&gt;(sen_1)) == *(reinterpret_cast&lt;int*&gt;(sen_2)));</div><div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160;        assert(n &gt; 0);</div><div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;</div><div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160;        <span class="comment">// Set sentinels</span></div><div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160;        *(<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">int</span>*<span class="keyword">&gt;</span>(sen_1)) *= -1;</div><div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;        *(<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">int</span>*<span class="keyword">&gt;</span>(sen_2)) *= -1;</div><div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;</div><div class="line"><a name="l00398"></a><span class="lineno">  398</span>&#160;        <span class="comment">// Check backwards</span></div><div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160;        <span class="keywordflow">if</span> (sen_1 != a) {</div><div class="line"><a name="l00400"></a><span class="lineno">  400</span>&#160;            <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a> b = <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a>((<span class="keywordtype">int</span>*) sen_1);</div><div class="line"><a name="l00401"></a><span class="lineno">  401</span>&#160;            --b;</div><div class="line"><a name="l00402"></a><span class="lineno">  402</span>&#160;</div><div class="line"><a name="l00403"></a><span class="lineno">  403</span>&#160;            <span class="keywordflow">if</span> (*b &gt; 0) {</div><div class="line"><a name="l00404"></a><span class="lineno">  404</span>&#160;                *(<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">int</span>*<span class="keyword">&gt;</span>(&amp;(*b))) += 2 * <span class="keyword">sizeof</span>(int) + *(reinterpret_cast&lt;int*&gt;(sen_1));</div><div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;                *(<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">int</span>*<span class="keyword">&gt;</span>(sen_2)) = *(<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">int</span>*<span class="keyword">&gt;</span>(&amp;(*b)));</div><div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160;                sen_1 = (<span class="keywordtype">char</span>*) &amp;(*b);</div><div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;            }</div><div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160;        }</div><div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;</div><div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;        <span class="comment">// Check forwards</span></div><div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160;        <span class="keywordflow">if</span> (sen_2 != &amp;a[N - 4]) {</div><div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160;            <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a> f = <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a>((<span class="keywordtype">int</span>*) sen_1);</div><div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;            ++f;</div><div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160;</div><div class="line"><a name="l00415"></a><span class="lineno">  415</span>&#160;            <span class="keywordflow">if</span> (*f &gt; 0) {</div><div class="line"><a name="l00416"></a><span class="lineno">  416</span>&#160;                *(<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">int</span>*<span class="keyword">&gt;</span>(sen_1)) += 2 * <span class="keyword">sizeof</span>(int) + *(reinterpret_cast&lt;int*&gt;(&amp;(*f)));</div><div class="line"><a name="l00417"></a><span class="lineno">  417</span>&#160;                *(<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">int</span>*<span class="keyword">&gt;</span>(((<span class="keywordtype">char</span>*) &amp;(*f)) + *f + 4)) = *(reinterpret_cast&lt;int*&gt;(sen_1));</div><div class="line"><a name="l00418"></a><span class="lineno">  418</span>&#160;            }</div><div class="line"><a name="l00419"></a><span class="lineno">  419</span>&#160;        }</div><div class="line"><a name="l00420"></a><span class="lineno">  420</span>&#160;</div><div class="line"><a name="l00421"></a><span class="lineno">  421</span>&#160;        <span class="comment">// Check if deallocate broke anything</span></div><div class="line"><a name="l00422"></a><span class="lineno">  422</span>&#160;        assert(valid());</div><div class="line"><a name="l00423"></a><span class="lineno">  423</span>&#160;    }</div><div class="line"><a name="l00424"></a><span class="lineno">  424</span>&#160;</div><div class="line"><a name="l00425"></a><span class="lineno">  425</span>&#160;    <span class="comment">// -----</span></div><div class="line"><a name="l00426"></a><span class="lineno">  426</span>&#160;    <span class="comment">// print</span></div><div class="line"><a name="l00427"></a><span class="lineno">  427</span>&#160;    <span class="comment">// -----</span></div><div class="line"><a name="l00428"></a><span class="lineno">  428</span>&#160;</div><div class="line"><a name="l00434"></a><span class="lineno">  434</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span> <span class="comment">// cin, cout</span></div><div class="line"><a name="l00435"></a><span class="lineno"><a class="line" href="classmy__allocator.html#a81a6bb50345d4b84381e5115bddc148b">  435</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classmy__allocator.html#a81a6bb50345d4b84381e5115bddc148b">print</a>(std::ostream&amp; w) {</div><div class="line"><a name="l00436"></a><span class="lineno">  436</span>&#160;        <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a> b = this-&gt;<a class="code" href="classmy__allocator.html#a7b5afad4b9378cb1a582fe1c8d229a60">begin</a>();</div><div class="line"><a name="l00437"></a><span class="lineno">  437</span>&#160;        <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a> e = this-&gt;<a class="code" href="classmy__allocator.html#a16254433a0dbd050ec409090f7e9777e">end</a>();</div><div class="line"><a name="l00438"></a><span class="lineno">  438</span>&#160;</div><div class="line"><a name="l00439"></a><span class="lineno">  439</span>&#160;        <span class="keywordflow">while</span> (b != e) {</div><div class="line"><a name="l00440"></a><span class="lineno">  440</span>&#160;            w &lt;&lt; *b;</div><div class="line"><a name="l00441"></a><span class="lineno">  441</span>&#160;            ++b;</div><div class="line"><a name="l00442"></a><span class="lineno">  442</span>&#160;            <span class="keywordflow">if</span> (b != e) std::cout &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;</div><div class="line"><a name="l00443"></a><span class="lineno">  443</span>&#160;        }</div><div class="line"><a name="l00444"></a><span class="lineno">  444</span>&#160;        w &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;</div><div class="line"><a name="l00445"></a><span class="lineno">  445</span>&#160;    }</div><div class="line"><a name="l00446"></a><span class="lineno">  446</span>&#160;</div><div class="line"><a name="l00447"></a><span class="lineno">  447</span>&#160;    <span class="comment">// -------</span></div><div class="line"><a name="l00448"></a><span class="lineno">  448</span>&#160;    <span class="comment">// destroy</span></div><div class="line"><a name="l00449"></a><span class="lineno">  449</span>&#160;    <span class="comment">// -------</span></div><div class="line"><a name="l00450"></a><span class="lineno">  450</span>&#160;</div><div class="line"><a name="l00455"></a><span class="lineno"><a class="line" href="classmy__allocator.html#a3d33fb5f0af755715d1a0a2bb48f0635">  455</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classmy__allocator.html#a3d33fb5f0af755715d1a0a2bb48f0635">destroy</a> (pointer p)<span class="keyword"> const </span>{</div><div class="line"><a name="l00456"></a><span class="lineno">  456</span>&#160;        p-&gt;~T();               <span class="comment">// this is correct</span></div><div class="line"><a name="l00457"></a><span class="lineno">  457</span>&#160;        assert(valid());</div><div class="line"><a name="l00458"></a><span class="lineno">  458</span>&#160;    }</div><div class="line"><a name="l00459"></a><span class="lineno">  459</span>&#160;</div><div class="line"><a name="l00460"></a><span class="lineno">  460</span>&#160;    <span class="comment">// -----------</span></div><div class="line"><a name="l00461"></a><span class="lineno">  461</span>&#160;    <span class="comment">// operator []</span></div><div class="line"><a name="l00462"></a><span class="lineno">  462</span>&#160;    <span class="comment">// -----------</span></div><div class="line"><a name="l00463"></a><span class="lineno">  463</span>&#160;</div><div class="line"><a name="l00468"></a><span class="lineno"><a class="line" href="classmy__allocator.html#afce70a1babca1d1ed59b595cb44818cf">  468</a></span>&#160;    <span class="keywordtype">int</span>&amp; <a class="code" href="classmy__allocator.html#afce70a1babca1d1ed59b595cb44818cf">operator [] </a>(<span class="keywordtype">int</span> i) {</div><div class="line"><a name="l00469"></a><span class="lineno">  469</span>&#160;        <span class="keywordflow">return</span> *<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">int</span>*<span class="keyword">&gt;</span>(&amp;a[i]);</div><div class="line"><a name="l00470"></a><span class="lineno">  470</span>&#160;    }</div><div class="line"><a name="l00471"></a><span class="lineno">  471</span>&#160;</div><div class="line"><a name="l00472"></a><span class="lineno">  472</span>&#160;    <span class="comment">// -----------</span></div><div class="line"><a name="l00473"></a><span class="lineno">  473</span>&#160;    <span class="comment">// operator []</span></div><div class="line"><a name="l00474"></a><span class="lineno">  474</span>&#160;    <span class="comment">// -----------</span></div><div class="line"><a name="l00475"></a><span class="lineno">  475</span>&#160;</div><div class="line"><a name="l00480"></a><span class="lineno"><a class="line" href="classmy__allocator.html#a449c644c9fe5f4e832443fac06716c94">  480</a></span>&#160;    <span class="keyword">const</span> <span class="keywordtype">int</span>&amp; <a class="code" href="classmy__allocator.html#afce70a1babca1d1ed59b595cb44818cf">operator [] </a>(<span class="keywordtype">int</span> i)<span class="keyword"> const </span>{</div><div class="line"><a name="l00481"></a><span class="lineno">  481</span>&#160;        <span class="keywordflow">return</span> *<span class="keyword">reinterpret_cast&lt;</span><span class="keyword">const </span><span class="keywordtype">int</span>*<span class="keyword">&gt;</span>(&amp;a[i]);</div><div class="line"><a name="l00482"></a><span class="lineno">  482</span>&#160;    }</div><div class="line"><a name="l00483"></a><span class="lineno">  483</span>&#160;</div><div class="line"><a name="l00484"></a><span class="lineno">  484</span>&#160;    <span class="comment">// -----</span></div><div class="line"><a name="l00485"></a><span class="lineno">  485</span>&#160;    <span class="comment">// begin</span></div><div class="line"><a name="l00486"></a><span class="lineno">  486</span>&#160;    <span class="comment">// -----</span></div><div class="line"><a name="l00487"></a><span class="lineno">  487</span>&#160;</div><div class="line"><a name="l00492"></a><span class="lineno"><a class="line" href="classmy__allocator.html#a7b5afad4b9378cb1a582fe1c8d229a60">  492</a></span>&#160;    <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a> <a class="code" href="classmy__allocator.html#a7b5afad4b9378cb1a582fe1c8d229a60">begin</a> () {</div><div class="line"><a name="l00493"></a><span class="lineno">  493</span>&#160;        <span class="keywordflow">return</span> <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a>(reinterpret_cast&lt;int*&gt;(&amp;a[0]));</div><div class="line"><a name="l00494"></a><span class="lineno">  494</span>&#160;    }</div><div class="line"><a name="l00495"></a><span class="lineno">  495</span>&#160;</div><div class="line"><a name="l00496"></a><span class="lineno">  496</span>&#160;    <span class="comment">// -----</span></div><div class="line"><a name="l00497"></a><span class="lineno">  497</span>&#160;    <span class="comment">// begin</span></div><div class="line"><a name="l00498"></a><span class="lineno">  498</span>&#160;    <span class="comment">// -----</span></div><div class="line"><a name="l00499"></a><span class="lineno">  499</span>&#160;</div><div class="line"><a name="l00504"></a><span class="lineno"><a class="line" href="classmy__allocator.html#a06f4504ec408574274330a139b801357">  504</a></span>&#160;    <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a> <a class="code" href="classmy__allocator.html#a06f4504ec408574274330a139b801357">begin</a> ()<span class="keyword"> const </span>{</div><div class="line"><a name="l00505"></a><span class="lineno">  505</span>&#160;        <span class="keywordflow">return</span> <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a>(reinterpret_cast&lt;const int*&gt;(&amp;a[0]));</div><div class="line"><a name="l00506"></a><span class="lineno">  506</span>&#160;    }</div><div class="line"><a name="l00507"></a><span class="lineno">  507</span>&#160;</div><div class="line"><a name="l00508"></a><span class="lineno">  508</span>&#160;    <span class="comment">// ---</span></div><div class="line"><a name="l00509"></a><span class="lineno">  509</span>&#160;    <span class="comment">// end</span></div><div class="line"><a name="l00510"></a><span class="lineno">  510</span>&#160;    <span class="comment">// ---</span></div><div class="line"><a name="l00511"></a><span class="lineno">  511</span>&#160;</div><div class="line"><a name="l00516"></a><span class="lineno"><a class="line" href="classmy__allocator.html#a16254433a0dbd050ec409090f7e9777e">  516</a></span>&#160;    <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a> <a class="code" href="classmy__allocator.html#a16254433a0dbd050ec409090f7e9777e">end</a> () {</div><div class="line"><a name="l00517"></a><span class="lineno">  517</span>&#160;        <span class="keywordflow">return</span> <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a>((<span class="keywordtype">int</span>*) (&amp;a[N]));</div><div class="line"><a name="l00518"></a><span class="lineno">  518</span>&#160;    }</div><div class="line"><a name="l00519"></a><span class="lineno">  519</span>&#160;</div><div class="line"><a name="l00520"></a><span class="lineno">  520</span>&#160;    <span class="comment">// ---</span></div><div class="line"><a name="l00521"></a><span class="lineno">  521</span>&#160;    <span class="comment">// end</span></div><div class="line"><a name="l00522"></a><span class="lineno">  522</span>&#160;    <span class="comment">// ---</span></div><div class="line"><a name="l00523"></a><span class="lineno">  523</span>&#160;</div><div class="line"><a name="l00528"></a><span class="lineno"><a class="line" href="classmy__allocator.html#a3b04c26fda6b3def2c5b2d3058366b72">  528</a></span>&#160;    <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a> <a class="code" href="classmy__allocator.html#a3b04c26fda6b3def2c5b2d3058366b72">end</a> ()<span class="keyword"> const </span>{</div><div class="line"><a name="l00529"></a><span class="lineno">  529</span>&#160;        <span class="keywordflow">return</span> <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a>((<span class="keyword">const</span> <span class="keywordtype">int</span>*) (&amp;a[N]));</div><div class="line"><a name="l00530"></a><span class="lineno">  530</span>&#160;    }</div><div class="line"><a name="l00531"></a><span class="lineno">  531</span>&#160;};</div><div class="line"><a name="l00532"></a><span class="lineno">  532</span>&#160;</div><div class="line"><a name="l00533"></a><span class="lineno">  533</span>&#160;<span class="keywordtype">void</span> allocator_run (std::istream&amp; r, std::ostream&amp; w);</div><div class="line"><a name="l00534"></a><span class="lineno">  534</span>&#160;</div><div class="line"><a name="l00535"></a><span class="lineno">  535</span>&#160;<span class="preprocessor">#endif // Allocator_h</span></div><div class="ttc" id="classmy__allocator_html_ab9b3cc6d95fad1ab70c09bc1c4de2597"><div class="ttname"><a href="classmy__allocator.html#ab9b3cc6d95fad1ab70c09bc1c4de2597">my_allocator::allocate</a></div><div class="ttdeci">pointer allocate(size_type n) const</div><div class="ttdef"><b>Definition:</b> Allocator.h:304</div></div>
<div class="ttc" id="classmy__allocator_html_ae072d6037f9f72b54303533033ed188d"><div class="ttname"><a href="classmy__allocator.html#ae072d6037f9f72b54303533033ed188d">my_allocator::my_allocator</a></div><div class="ttdeci">my_allocator()</div><div class="ttdef"><b>Definition:</b> Allocator.h:279</div></div>
<div class="ttc" id="classmy__allocator_html_afce70a1babca1d1ed59b595cb44818cf"><div class="ttname"><a href="classmy__allocator.html#afce70a1babca1d1ed59b595cb44818cf">my_allocator::operator[]</a></div><div class="ttdeci">int &amp; operator[](int i)</div><div class="ttdef"><b>Definition:</b> Allocator.h:468</div></div>
<div class="ttc" id="classmy__allocator_html_a3d33fb5f0af755715d1a0a2bb48f0635"><div class="ttname"><a href="classmy__allocator.html#a3d33fb5f0af755715d1a0a2bb48f0635">my_allocator::destroy</a></div><div class="ttdeci">void destroy(pointer p) const</div><div class="ttdef"><b>Definition:</b> Allocator.h:455</div></div>
<div class="ttc" id="classmy__allocator_html_a3b04c26fda6b3def2c5b2d3058366b72"><div class="ttname"><a href="classmy__allocator.html#a3b04c26fda6b3def2c5b2d3058366b72">my_allocator::end</a></div><div class="ttdeci">const_iterator end() const</div><div class="ttdef"><b>Definition:</b> Allocator.h:528</div></div>
<div class="ttc" id="classmy__allocator_html"><div class="ttname"><a href="classmy__allocator.html">my_allocator</a></div><div class="ttdef"><b>Definition:</b> Allocator.h:25</div></div>
<div class="ttc" id="classmy__allocator_html_a16254433a0dbd050ec409090f7e9777e"><div class="ttname"><a href="classmy__allocator.html#a16254433a0dbd050ec409090f7e9777e">my_allocator::end</a></div><div class="ttdeci">iterator end()</div><div class="ttdef"><b>Definition:</b> Allocator.h:516</div></div>
<div class="ttc" id="classmy__allocator_1_1const__iterator_html"><div class="ttname"><a href="classmy__allocator_1_1const__iterator.html">my_allocator::const_iterator</a></div><div class="ttdef"><b>Definition:</b> Allocator.h:180</div></div>
<div class="ttc" id="classmy__allocator_html_af88d75eee73684bd8d2c42f663c4dd37"><div class="ttname"><a href="classmy__allocator.html#af88d75eee73684bd8d2c42f663c4dd37">my_allocator::deallocate</a></div><div class="ttdeci">void deallocate(pointer p, size_type n) const</div><div class="ttdef"><b>Definition:</b> Allocator.h:386</div></div>
<div class="ttc" id="classmy__allocator_html_a7b5afad4b9378cb1a582fe1c8d229a60"><div class="ttname"><a href="classmy__allocator.html#a7b5afad4b9378cb1a582fe1c8d229a60">my_allocator::begin</a></div><div class="ttdeci">iterator begin()</div><div class="ttdef"><b>Definition:</b> Allocator.h:492</div></div>
<div class="ttc" id="classmy__allocator_html_a821500e9bdd812dd28bcf1740f2fdd58"><div class="ttname"><a href="classmy__allocator.html#a821500e9bdd812dd28bcf1740f2fdd58">my_allocator::construct</a></div><div class="ttdeci">void construct(pointer p, const_reference v) const</div><div class="ttdef"><b>Definition:</b> Allocator.h:370</div></div>
<div class="ttc" id="classmy__allocator_1_1iterator_html"><div class="ttname"><a href="classmy__allocator_1_1iterator.html">my_allocator::iterator</a></div><div class="ttdef"><b>Definition:</b> Allocator.h:88</div></div>
<div class="ttc" id="classmy__allocator_html_a81a6bb50345d4b84381e5115bddc148b"><div class="ttname"><a href="classmy__allocator.html#a81a6bb50345d4b84381e5115bddc148b">my_allocator::print</a></div><div class="ttdeci">void print(std::ostream &amp;w)</div><div class="ttdef"><b>Definition:</b> Allocator.h:435</div></div>
<div class="ttc" id="classmy__allocator_html_a06f4504ec408574274330a139b801357"><div class="ttname"><a href="classmy__allocator.html#a06f4504ec408574274330a139b801357">my_allocator::begin</a></div><div class="ttdeci">const_iterator begin() const</div><div class="ttdef"><b>Definition:</b> Allocator.h:504</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
